#!/usr/bin/perl

$var     = 1;
$varname = "var";

@lines = <STDIN>;

$max = scalar(@lines);
$i   = 0;

print "<?xml version=\"1.0\" encoding=\"iso-8859-1\" standalone=\"no\"?>\n";
print
"<!DOCTYPE SURVEY PUBLIC \"-//Joel Palmius//DTD Survey markup definition//EN\" \"http://www.modsurvey.org/mod_survey/survey-3.2.5.dtd\">\n";
print "<SURVEY TITLE=\"Autogenerated\">\n";

while ($i < $max)
{
    $matched = 0;

    $caption = $lines[$i];
    chomp($caption);

    if ($caption =~ m/^\#/)
    {
        $caption = "";
    }

    if ($caption)
    {
        $name = "$varname$var";

        $i++;

        $line = $lines[$i];

        if ($line =~ m/\.\./)
        {

            # assume LICKERT

            ($left, $mid) = split(/\./, $line, 2);

            $mid = "." . $mid;
            $left =~ s/\ +$//;

            $right = $mid;
            $right =~ s/^\.+//;

            $steps = length($mid) - length($right);

            chomp($right);
            $right =~ s/^\ +//;
            $right =~ s/\ +$//;

            print
"  <LICKERT NAME=\"$name\" CAPTION=\"$caption\" LEFTTAG=\"$left\" RIGHTTAG=\"$right\" STEPS=\"$steps\" />\n";
            $i++;

            $line = $lines[$i];
            chomp($line);

            while ($line && ($i < $max))
            {
                print "  <COMMENT>Junk at line $i: \"$line\"</COMMENT>\n";
                $i++;
                $line = $lines[$i];
                chomp($line);
            }

            $matched = 1;
        }

        if ($line =~ m/\_/)
        {

            # assume TEXT
            print "  <TEXT NAME=\"$name\" CAPTION=\"$caption\" />\n";
            $i++;

            $line = $lines[$i];
            chomp($line);

            while ($line && ($i < $max))
            {
                print "  <COMMENT>Junk at line $i: \"$line\"</COMMENT>\n";
                $i++;
                $line = $lines[$i];
                chomp($line);
            }

            $matched = 1;
        }

        if ($line =~ m/^\*/)
        {

            # assume CHOICE
            print "  <CHOICE NAME=\"$name\" CAPTION=\"$caption\">\n";

            $line = $lines[$i];
            chomp($line);

            $val = 1;

            while ($line && ($i < $max))
            {
                $line =~ s/\*//g;
                $line =~ s/^\ +//;
                $line =~ s/\ +$//;

                print "    <CHOICEELEMENT VALUE=\"$val\" CAPTION=\"$line\" />\n";

                $val++;
                $i++;
                $line = $lines[$i];
                chomp($line);
            }

            print "  </CHOICE>\n";

            $matched = 1;
        }

        if ($line =~ m/^\-/)
        {

            # assume LIST

            print "  <LIST NAME=\"$name\" CAPTION=\"$caption\">\n";

            $line = $lines[$i];
            chomp($line);

            while ($line && ($i < $max))
            {
                $line =~ s/^\ +//;
                $line =~ s/^\-//g;
                $line =~ s/^\ +//;
                $line =~ s/\ +$//;

                print "    <LISTELEMENT CAPTION=\"$line\" />\n";

                $i++;
                $line = $lines[$i];
                chomp($line);
            }

            print "  </LIST>\n";

            $matched = 1;
        }

        if (!$matched && $line)
        {
            if (!($line =~ m/^\#/))
            {
                chomp($line);
                print
"  <COMMENT>Unparseable line $i: \"$line\" (caption was \"$caption\")</COMMENT>\n";
            }
        }

        if ($matched)
        {
            $var++;
        }
    }

    $i++;
}

print "</SURVEY>\n";

